
Redmine - Defect #16038

Issue#css_classes corrupts user.groups association cache

2014-02-06 13:09 - Toshi MARUYAMA

Status: Closed Start date:  

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: Code cleanup/refactoring Estimated time: 0.00 hour

Target version: 2.4.3   

Resolution: Fixed Affected version:  

Description

https://github.com/redmine/redmine/pull/27

diff --git a/app/models/issue.rb b/app/models/issue.rb

index debb931..b9a2b20 100644

--- a/app/models/issue.rb

+++ b/app/models/issue.rb

@@ -1091,7 +1091,7 @@ def css_classes(user=User.current)

     if user.logged?

       s << ' created-by-me' if author_id == user.id

       s << ' assigned-to-me' if assigned_to_id == user.id

-      s << ' assigned-to-my-group' if user.groups.any? {|g| g.id = assigned_to_id}

+      s << ' assigned-to-my-group' if user.groups.any? {|g| g.id == assigned_to_id}

     end

     s

   end

 If user belongs any groups, 'assigned-to-my-group' is set.

It is wrong.

Related issues:

Related to Redmine - Defect #12681: Treat group assignments as assigned to me Closed

Related to Redmine - Defect #16166: Incorrect data on Issues assigned to me o... Closed

Is duplicate of Redmine - Patch #16002: Assigned-to-my-group css corrupts use... Closed

Associated revisions

Revision 12844 - 2014-02-06 13:16 - Toshi MARUYAMA

fix wrong issue 'assigned-to-my-group' css class (#16038)

Revision 12852 - 2014-02-07 09:06 - Jean-Philippe Lang

Merged r12844 (#16038).

History

#1 - 2014-02-06 13:10 - Toshi MARUYAMA

- Related to Defect #12681: Treat group assignments as assigned to me added

#2 - 2014-02-06 13:10 - Toshi MARUYAMA

- Category set to UI

#3 - 2014-02-06 13:29 - Toshi MARUYAMA

- Private changed from No to Yes

#4 - 2014-02-06 13:33 - Toshi MARUYAMA

It has serious side effect.

1.9.3p484 :002 > user = Group.find(10).users.first

1.9.3p484 :004 > user.groups.collect(&:id)

  Group Load (1.0ms)  SELECT "users".* FROM "users" INNER JOIN "groups_users" ON "users"."id" = "groups_users"
."group_id" WHERE "users"."type" IN ('Group') AND "groups_users"."user_id" = 8

 => [10, 11] 

1.9.3p484 :005 > assigned_to_id = 1

 => 1 

1.9.3p484 :006 > user.groups.any? {|g| g.id == assigned_to_id}

 => false 

1.9.3p484 :007 > user.groups.any? {|g| g.id = assigned_to_id}

 => true 

1.9.3p484 :008 > user.groups.collect(&:id)

 => [1, 11] 

#5 - 2014-02-06 14:07 - Toshi MARUYAMA

But, it seems no effect on database.

1.9.3p484 :011 > user.save!

   (0.3ms)  begin transaction

   (0.2ms)  commit transaction

 => true 

1.9.3p484 :012 > user.groups.collect(&:id)

 => [1, 11] 

1.9.3p484 :013 > user.reload

  User Load (0.5ms)  SELECT "users".* FROM "users" WHERE "users"."type" IN ('User', 'AnonymousUser') AND "user

s"."id" = ? LIMIT 1  [["id", 8]]

 => #<User id: 8, login: "miscuser8", hashed_password: "8f659c8d7c072f189374edacfa90d6abbc26d8ed", firstname: 

"User", lastname: "Misc", mail: "miscuser8@foo.bar", admin: false, status: 1, last_login_on: nil, language: "i

t", auth_source_id: nil, created_on: "2006-07-19 17:33:19", updated_on: "2006-07-19 17:33:19", type: "User", i

dentity_url: nil, mail_notification: "only_my_events", salt: "7599f9963ec07b5a3b55b354407120c0", must_change_p

asswd: false> 

1.9.3p484 :014 > user.groups.collect(&:id)

  Group Load (0.5ms)  SELECT "users".* FROM "users" INNER JOIN "groups_users" ON "users"."id" = "groups_users"

."group_id" WHERE "users"."type" IN ('Group') AND "groups_users"."user_id" = 8

 => [10, 11] 

#6 - 2014-02-06 19:05 - Jean-Philippe Lang

- Is duplicate of Patch #16002: Assigned-to-my-group css corrupts user.groups association cache added

#7 - 2014-02-07 09:08 - Jean-Philippe Lang

- Subject changed from Issue 'assigned-to-my-group' css class is wrong to Issue#css_classes corrupts user.groups association cache

- Category changed from UI to Code cleanup/refactoring

- Status changed from New to Closed

- Private changed from Yes to No

- Resolution set to Fixed

#8 - 2014-02-28 13:28 - Jean-Philippe Lang

- Related to Defect #16166: Incorrect data on Issues assigned to me on MyPage added
